﻿using Microsoft.Phone.Net.NetworkInformation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Phone7
{
    /// <summary>
    /// 将网络接口类型转换为直观的表达方式
    /// </summary>
    public class InterfaceTypeConvert
    {
        public static string ConvertSub(NetworkInterfaceSubType subType)
        {
            switch (subType)
            {
                case NetworkInterfaceSubType.Cellular_3G:
                case NetworkInterfaceSubType.Cellular_EVDO:
                case NetworkInterfaceSubType.Cellular_EVDV:
                    return "3G";
                case NetworkInterfaceSubType.Cellular_HSPA:
                    return "3.5G";
                case NetworkInterfaceSubType.Cellular_GPRS:
                case NetworkInterfaceSubType.Cellular_EDGE:
                case NetworkInterfaceSubType.Cellular_1XRTT:
                    return "2.5G";
                default:
                    return "非蜂窝";
            }
        }


        public static string Convert(NetworkInterfaceType type)
        {
            switch (type)
            {
                case NetworkInterfaceType.MobileBroadbandCdma:
                    return "CDMA";
                case NetworkInterfaceType.MobileBroadbandGsm:
                    return "CSM";
                case NetworkInterfaceType.Wireless80211:
                    return "WiFi蓝牙";
                case NetworkInterfaceType.Ethernet:
                    return "以太网";
                case NetworkInterfaceType.None:
                    return "无网络";
                default:
                    return "其他";
            }
        }

    }
}
