﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Net.NetworkInformation;
using System.Net.Sockets;
using System.Text;

namespace Phone7
{
    public partial class MainPage : PhoneApplicationPage
    {
        // 构造函数
        public MainPage()
        {
            InitializeComponent();

        }
        Socket socket;
        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {

            //移动运营商
            textblock1.Text = DeviceNetworkInformation.CellularMobileOperator;



            //网络信息
            System.Text.StringBuilder sb = new System.Text.StringBuilder();
            sb.Append("网络是否可用:  ");
            sb.AppendLine(DeviceNetworkInformation.IsNetworkAvailable.ToString());
            sb.Append("是否启用蜂窝数据:  ");
            sb.AppendLine(DeviceNetworkInformation.IsCellularDataEnabled.ToString());
            sb.Append("是否允许漫游:  ");
            sb.AppendLine(DeviceNetworkInformation.IsCellularDataRoamingEnabled.ToString());
            sb.Append("是否启用Wi-Fi:  ");
            sb.AppendLine(DeviceNetworkInformation.IsWiFiEnabled.ToString());

            //网络接口信息
            sb.Append("网络接口类型:  ");
            var networkInterfaceType = NetworkInterface.NetworkInterfaceType;
            var networkInterfaceTypeString = networkInterfaceType.ToString() + "(" + InterfaceTypeConvert.Convert(networkInterfaceType) + ")";
            sb.AppendLine(networkInterfaceTypeString);

            sb.Append("网络接口子类型:  ");
            var networkSubInterfaceTypeString = string.Empty;
            DeviceNetworkInformation.ResolveHostNameAsync(new DnsEndPoint("www.baidu.com", 80),
                new NameResolutionCallback(x =>
                    {
                        networkSubInterfaceTypeString = x.NetworkInterface.InterfaceSubtype.ToString() + "[" + InterfaceTypeConvert.ConvertSub(x.NetworkInterface.InterfaceSubtype) + "]";

                        sb.AppendLine(networkSubInterfaceTypeString);
                        Dispatcher.BeginInvoke(() => { textblock2.Text = sb.ToString(); });
                    }), null);



            //套接字连接信息
            DnsEndPoint hostEntry = new DnsEndPoint("www.baidu.com", 80);
            socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            //设置连接要求，必须为使用蜂窝技术网络
            socket.SetNetworkRequirement(NetworkSelectionCharacteristics.Cellular);
            SocketAsyncEventArgs socketEventArg = new SocketAsyncEventArgs();
            socketEventArg.RemoteEndPoint = hostEntry;
            socketEventArg.Completed += new EventHandler<SocketAsyncEventArgs>(delegate(object s, SocketAsyncEventArgs e1)
            {
                NetworkInterfaceInfo netInterfaceInfo = socket.GetCurrentNetworkInterface();
                StringBuilder sb2 = new StringBuilder();
                sb2.AppendLine("最后更新: " + DateTime.Now.ToString());
                sb2.Append("网络接口名: ");
                sb2.AppendLine(netInterfaceInfo.InterfaceName);
                sb2.Append("网络接口状态: ");
                sb2.AppendLine(netInterfaceInfo.InterfaceState.ToString());
                sb2.Append("网络接口类型: ");
                sb2.AppendLine(netInterfaceInfo.InterfaceType.ToString());
                sb2.Append("网络接口子类型: ");
                sb2.AppendLine(netInterfaceInfo.InterfaceSubtype.ToString());
                Dispatcher.BeginInvoke(() => textblock3.Text = sb2.ToString());
            });
            socket.ConnectAsync(socketEventArg);



            base.OnNavigatedTo(e);
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Page1.xaml", UriKind.Relative));
        }

    }
}